{
Interface de linha de comando do google translator.
Por Fabiano Ferreira.
Em abril de 2022.

Rotinas de processamento dos parmetros da linha de comando
}

unit trdprocessa;

interface

procedure processa;

implementation
uses trdrede, sysutils;

procedure apresenta;

begin
writeln ('TRDCMD - interface de linha de comando para o google tradutor');
writeln ('Verso 2022.05.04.0');
writeln ('Por Fabiano Ferreira');
writeln ('http://www.winvox.com.br');
writeln;
writeln ('Para ajuda digite: trdcmd -h ou trdcmd -help ou trdcmd -?');
end;

procedure listaidiomas;
begin
writeln ('Listando idiomas disponveis:');
writeln ('Formato: cod=idioma');
writeln ('af=Africner');
writeln ('sq=Albans');
writeln ('de=Alemo');
writeln ('am=Amrico');
writeln ('ar=rabe');
writeln ('hy=Armnio');
writeln ('az=Azerbaijano');
writeln ('eu=Basco');
writeln ('bn=Bengali');
writeln ('be=Bielo-russo');
writeln ('my=Birmans');
writeln ('bs=Bsnio');
writeln ('bg=Blgaro');
writeln ('kn=Canars');
writeln ('ca=Catalo');
writeln ('kk=Cazaque');
writeln ('ceb=Cebuano');
writeln ('ny=Chicheua');
writeln ('zh-CN=Chins');
writeln ('sn=Chona');
writeln ('si=Cingals');
writeln ('ko=Coreano');
writeln ('co=Corso');
writeln ('ht=Crioulo haitiano');
writeln ('hr=Croata');
writeln ('ku=Curdo');
writeln ('da=Dinamarqus');
writeln ('sk=Eslovaco');
writeln ('sl=Esloveno');
writeln ('es=Espanhol');
writeln ('eo=Esperanto');
writeln ('et=Estoniano');
writeln ('tl=Filipino');
writeln ('fi=Finlands');
writeln ('fr=Francs');
writeln ('fy=Frsio');
writeln ('gd=Galico escocs');
writeln ('gl=Galego');
writeln ('cy=Gals');
writeln ('ka=Georgiano');
writeln ('el=Grego');
writeln ('gu=Guzerate');
writeln ('ha=Hau');
writeln ('haw=Havaiano');
writeln ('iw=Hebraico');
writeln ('hi=Hindi');
writeln ('hmn=Hmong');
writeln ('nl=Holands');
writeln ('hu=Hngaro');
writeln ('ig=Igbo');
writeln ('yi=Idiche');
writeln ('id=Indonsio');
writeln ('en=Ingls');
writeln ('yo=Ioruba');
writeln ('ga=Irlands');
writeln ('is=Islands');
writeln ('it=Italiano');
writeln ('ja=Japons');
writeln ('jw=Javans');
writeln ('km=Khmer');
writeln ('rw=Kinyarwanda');
writeln ('lo=Laosiano');
writeln ('la=Latim');
writeln ('lv=Leto');
writeln ('lt=Lituano');
writeln ('lb=Luxemburgus');
writeln ('mk=Macednio');
writeln ('ml=Malaiala');
writeln ('ms=Malaio');
writeln ('mg=Malgaxe');
writeln ('mt=Malts');
writeln ('mi=Maori');
writeln ('mr=Marata');
writeln ('mn=Mongol');
writeln ('ne=Nepals');
writeln ('no=Noruegus');
writeln ('or=Ori');
writeln ('ps=Pachto');
writeln ('fa=Persa');
writeln ('pl=Polons');
writeln ('pt=Portugus');
writeln ('pa=Punjabi');
writeln ('ky=Quirguiz');
writeln ('ro=Romeno');
writeln ('ru=Russo');
writeln ('sm=Samoano');
writeln ('sr=Srvio');
writeln ('st=Sessoto');
writeln ('sd=Sindi');
writeln ('so=Somali');
writeln ('sw=Suale');
writeln ('sv=Sueco');
writeln ('su=Sundans');
writeln ('tg=Tadjique');
writeln ('th=Tailands');
writeln ('ta=Tmil');
writeln ('tt=Trtaro');
writeln ('cs=Tcheco');
writeln ('te=Telugo');
writeln ('tr=Turco');
writeln ('tk=Turcomano');
writeln ('uk=Ucraniano');
writeln ('ug=Uigur');
writeln ('ur=Urdu');
writeln ('uz=Uzbeque');
writeln ('vi=Vietnamita');
writeln ('xh=Xhosa');
writeln ('zu=Zulu');
Halt;
end;

procedure ajuda;
begin
Writeln ('Uso:');
Writeln ('trdcmd [-io <codlinguaorigem> -id <codlinguadestino> -f "frase a traduzir"|[-ao <nomearqorigem> -ad <nomearqdestino>]][-h|-help|-?][-l]');
writeln ('Opes:');
writeln ('-io <codlinguaorigem>    Define o idioma de origem');
Writeln ('-id <codlinguadestino>    Define o idioma de destino');
Writeln ('-f "Frase a traduzir"    envia frase ao google para traduo');
writeln ('-ao <nomearqorigem>    define um arquivo de texto para ser traduzido');
writeln ('-ad <nomearqdestino>    Salva a traduo do arquivo definido em -ao no arquivo destino');
Writeln ('-l    lista os idiomas disponveis');
writeln ('-h,-help,-?    mostra esta ajuda');
writeln;
writeln ('Digite trdcmd sem parmetros para exibir o nmero da verso do programa.');
halt;
end;

procedure processa;
var i : integer;
s : string;
podetraduzir : boolean;

linguaorigem, linguadestino: string;
frase: string;
nomearqorigem, nomearqdestino: string;

begin
podetraduzir := false;
for i:= 1 to paramcount do
begin
s:= uppercase(paramstr(i));

if (s = '-H') or
(s = '-?') or
(s = '-HELP') then
ajuda
else
if s = '-L' then
listaidiomas
else
if s = '-IO' then
linguaorigem := paramstr(i + 1)
else
if s = '-ID' then
linguadestino := paramstr(i + 1)
else
if s = '-F' then
frase := paramstr(i + 1)
else
if s = '-AO' then
nomearqorigem := paramstr(i+1)
else
if s = '-AD' then
nomearqdestino := paramstr(i+1);
end;

if (linguaorigem <> '') and
(linguadestino <> '') then
podetraduzir := true
else
begin
apresenta;
exit;
end;

if frase <> '' then
writeln (traduzfrase (linguaorigem,linguadestino,frase));

if (nomearqorigem <> '') and (nomearqdestino <> '') then
traduzarquivo (nomearqorigem,nomearqdestino,linguaorigem,linguadestino);

end;

end.
