{
Interface de linha de comando do google translator.
Por Fabiano Ferreira.
Em abril de 2022.

Rotinas de rede e comunicao com o google
}

unit trdrede;

interface

function traduzfrase(linguaorigem,linguadestino,frase: string): string;
procedure traduzarquivo(nomearqorigem,nomearqdestino,linguaorigem,linguadestino: string);

implementation
uses ngen, sysutils;

function subsCaracs(s: string) : string;
begin
    s := stringReplace(s,'&#39;','''',[rfreplaceall]);
    s := stringReplace(s,'&quot;','"',[rfreplaceall]);
    result := trim(s);
end;

function utfToAnsi (s: string): string;
var b, b2: byte;
    s2: string;
    i: integer;
begin
    s2 := '';
    s := s + ' ';
    i := 1;
    while i <= length (s) - 1 do
        begin
            b := ord(s[i]);
            if (b < $80) or ((b and $e0) <> $c0)then
                s2 := s2 + s[i]
            else
                begin
                    b2 := ord (s[i+1]) and $3f;
                    b := (b and $03) shl 6;
                    s2 := s2 + chr(b or b2);
                    i := i + 1;
                end;
            i := i + 1;
        end;
    utfToAnsi := s2;
end;

function ansiToUTF (s: string): string;
var b: byte;
    s2: string;
    i: integer;
begin
    s2 := '';
    for i := 1 to length (s) do
        begin
            b := ord(s[i]);
            if b <= $7f then
                s2 := s2 + s[i]
            else
                s2 := s2 + chr ($c0 or ((b shr 6) and $3f)) +
                           chr ($80 or (b and $3f));
        end;
    ansiToUTF := s2;
end;

{   transforma string para a codificao usada em URLs
{--------------------------------------------------------}


function stringToURL(s: string): string;
var i: integer;
begin
    result := '';
    for i := 1 to length(s) do
        begin
            if s[i] in ['0'..'9', 'a'..'z', 'A'..'Z', '.', '-', '_', '~'] then
                result := result + s[i]
            else
                result := result + '%' + intToHex(ord(s[i]), 2);
        end;
end;

{--------------------------------------------------------}
{   transforma string para a codificao usada em URLs
{--------------------------------------------------------}

function URLToString(s: string): string;

    function hex(c: char): integer;
    begin
        if c in ['0'..'9'] then result := ord(c) - ord('0')
        else
        if c in ['a'..'f'] then result := ord(c) - ord('a') + 10
        else
        if c in ['A'..'F'] then result := ord(c) - ord('A') + 10
        else
            result := 0;
    end;

var i, n: integer;

begin
    result := '';
    i := 1;
    while i <= length(s) do
        begin
            if (s[i] = '%') and (i <= length(s)-2) then
                begin
                    n := (hex(s[i+1]) shl 4) + hex(s[i+1]);
                    result := result + chr(n);
                    i := i + 3;
                end
            else
                begin
                    result := result + s[i];
                    i := i + 1;
                end;
        end;
end;

function traduzfrase(linguaorigem,linguadestino,frase: string): string;
var
buf: pbufrede;
p, sock : integer;
s : string;

begin
abrewinsock;
sock := abreConexaossl('translate.google.com',443);
if sock = -1 then
begin
writeln ('Erro: sem conexo com a internet.');
halt;
end;


writelnRede (sock,'GET /m?sl='+linguaorigem +'&tl='+linguadestino+'&q='+stringtourl(ansitoutf(frase))+' HTTP/1.1');
writelnRede (sock,'Host: translate.google.com');
writelnRede (sock,'User-Agent: Webvox');
writelnrede(sock,'Connection: Close');
writelnrede(sock,'Accept: */*');
writelnrede (sock,'Accept-Encoding: identity');

writelnRede (sock,'');
buf := inicbufrede(sock);

repeat
readlnbufrede(buf,s,0);
p := pos('"result-container">',s);
until (p > 0);
fechaconexao(sock);
fechawinsock;

p := p + 19;
s := copy(s,p,length(s)-p+1);
s := copy (s,1,pos('<',s)-1);
s := utftoansi(s);
s := subscaracs(s);
traduzfrase := s;
end;

procedure traduzarquivo(nomearqorigem,nomearqdestino,linguaorigem,linguadestino: string);
var arqorigem, arqdestino: text;
qlinhas, qporcento, linhastraduzidas, blocodecem : integer;
s : string;

function totaldelinhas(nomearqorigem:string): integer;
var i : integer;
begin
i := 0;
assignfile (arqorigem,nomearqorigem);
if (not fileexists(nomearqorigem)) then
begin
Writeln ('Arquivo origem no encontrado: '''+nomearqorigem+'''');
halt;
end;

reset(arqorigem);
while not eof(arqorigem) do
begin
readln (arqorigem,s);
i := i + 1;
end;
close(arqorigem);
totaldelinhas := i;
end;

begin
qlinhas := totaldelinhas(nomearqorigem);
assignfile (arqorigem,nomearqorigem);
if (not fileexists(nomearqorigem)) then
begin
Writeln ('Arquivo origem no encontrado: '''+nomearqorigem);
exit;
end;

assignfile (arqdestino,nomearqdestino);
reset(arqorigem);
rewrite(arqdestino);

while not eof(arqorigem) do
begin
readln(arqorigem,s);
writeln (arqdestino,traduzfrase(linguaorigem,linguadestino,s));
linhastraduzidas := linhastraduzidas + 1;
blocodecem := blocodecem + 1;
qporcento := (linhastraduzidas*100) div qlinhas;

writeln ('Traduzida '+inttostr(linhastraduzidas)+' / '+inttostr(qlinhas)+' linhas ('+inttostr(qporcento)+'%)');
if (blocodecem = 100) then
begin
sleep(5000);
blocodecem := 0;
end;
end;
close(arqorigem);
close(arqdestino);

writeln ('Traduo finalizada');
end;

end.
